#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "node.c"
#include "newconst.c"
#include "newvar.c"
#include "newop.c"
#include "inputcone.c"
#include "mark.c"
#include "aig.c"
#include "simp.c"
#include "find.c"
#include "insert.c"
#include "swap.c"
#include "newaig.c"
#include "abbrv.c"
#include "count.c"
#include "markaig.c"
#include "node2aig.c"
#include "visedge.c"
#include "visaux.c"
#include "vis.c"
int
main (void)
{
  Node *x, *y, *i, *o, *s, *t[3];
  AIG *a, *b, *c;
  int n;

  x = new_node_var (0);
  y = new_node_var (1);
  i = new_node_var (2);
  t[0] = new_node_op (XOR, x, y);
  t[1] = new_node_op (AND, x, y);
  t[2] = new_node_op (AND, t[0], i);
  s = new_node_op (XOR, t[0], i);
  o = new_node_op (OR, t[1], t[2]);

  input_cone_node (o);
  input_cone_node (s);
  mark_node (o, 0);
  mark_node (s, 0);

  assert (var_aig (0) == var_aig (0));
  assert (and_aig (var_aig (0), var_aig (1)) ==
	  and_aig (var_aig (1), var_aig (0)));

  a = xor_aig (var_aig (0), var_aig (1));
  n = count_aig (a);
  mark_aig (a, 0);
  printf ("number of nodes in XOR AIG is %d\n", n);

  b = node2aig (s);
  c = node2aig (o);
  n = count_aig (b) + count_aig (c);
  mark_aig (b, 0);
  mark_aig (c, 0);
  printf ("number of nodes in AIG for full adder %d\n", n);

  vis_aig (a);
  vis_aig (b);
  vis_aig (c);

  return 0;
}
